//--------------------------------------------------------------------------
// File and Version Information:
//      created at Thu Mar  7 01:08:19 CST 2002 by newPackage.sh
// Description:
//      Class trkEx
//      Exercise to handle CDFtrack
// Environment:
//
// Author List:
//
// Copyright Information:
//
//------------------------------------------------------------------------

#ifndef trkEx_HH
#define trkEx_HH

//----------------------
// Base Class Headers --
//----------------------
#include "Framework/APPModule.hh"
#ifdef CDF
#include "BaBar/Cdf.hh"
#endif

// for HepTuple
#include <HepTuple/HepFileManager.h>
#include <HepTuple/HepRootFileManager.h>
#include <HepTuple/HepHBookFileManager.h>
#include <HepTuple/HepHBookNtuple.h>
#include <HepTuple/HepNtuple.h>
#include <HepTuple/HepHist1D.h>
#include <HepTuple/Column.h>
#include <HepTuple/Block.h>


//              ---------------------
//              -- Class Interface --
//              ---------------------

class trkEx : public AppModule {

//--------------------
// Instance Members --
//--------------------

public:
  // Constructors
  trkEx( const char* const theName = "trkEx",
            const char* const theDescription = "trkEx module");

    // Destructor
  virtual ~trkEx();

    // Operations
  virtual AppResult beginJob( AbsEvent* aJob );
  virtual AppResult beginRun( AbsEvent* aRun );
  virtual AppResult event( AbsEvent* anEvent );
  virtual AppResult other( AbsEvent* anOther );
  virtual AppResult endRun( AbsEvent* aRun );
  virtual AppResult endJob( AbsEvent* aJob );
  virtual AppResult abortJob( AbsEvent* aJob );

  virtual AppModule* clone(const char* cloneName);

  const char*  rcsId() const;

  // class variables for Histogram
  HepFileManager* _manager;
  HepNtuple* _ntuple;

  struct {
    int bulkhead;
    int wedge;
    int layer;
    int side;
    int Q;
    float momentum;
    float pathlength;
    float x;
    float y;
    float z;
  } _var;

  ////////////////////////////////////
  // Data

  int _eventN;
};
#endif
